name: kde-qt6-core22-sdk
base: core22
version: 6.8.0
summary: KDE fork Qt Framework SDK
description: |
  Qt is a cross-platform application development framework widely used
  for developing software with graphical user interfaces (GUIs) and
  interactive functionality.
architectures:
  - build-on: amd64
  - build-on: arm64
  # - build-on: armhf
  # - build-on: ppc64el
grade: stable
confinement: strict

lint:
  ignore:
    - classic
    - library

package-repositories:
  - type: apt
    url: https://deb.nodesource.com/node_20.x
    components: [main]
    suites: [nodistro]
    key-id: 6F71F525282841EEDAF851B42F59B5F99B1BE0B4

parts:
  qt6:
    plugin: cmake
    source: https://invent.kde.org/qt/qt/qt5.git
    source-tag: $SNAPCRAFT_PROJECT_VERSION
    source-depth: 1
    cmake-generator: Ninja
    cmake-parameters:
      - -DCMAKE_BUILD_TYPE=Release
      - -DCMAKE_INSTALL_PREFIX=/usr
      - -DINSTALL_BINDIR=/usr/bin/qt6
      - -DINSTALL_LIBDIR=lib/$CRAFT_ARCH_TRIPLET_BUILD_FOR
      - -DINSTALL_LIBEXECDIR=lib/qt6/libexec
      - -DINSTALL_ARCHDATADIR=lib/$CRAFT_ARCH_TRIPLET_BUILD_FOR/qt6
      - -DINSTALL_EXAMPLESDIR=lib/$CRAFT_ARCH_TRIPLET_BUILD_FOR/qt6/examples
      - -DINSTALL_DATADIR=share/qt6
      - -DINSTALL_HOSTDATADIR=lib/$CRAFT_ARCH_TRIPLET_BUILD_FOR/qt6
      - -DINSTALL_SYSCONFDIR=/share
      - -DINSTALL_INCLUDEDIR=include/$CRAFT_ARCH_TRIPLET_BUILD_FOR/qt6
      - -DINSTALL_PLUGINDIR=lib/$CRAFT_ARCH_TRIPLET_BUILD_FOR/qt6/plugins
      - -DINSTALL_TRANSLATIONDIR=share/qt6/translations
      - -DINSTALL_MKSPECSDIR=lib/$CRAFT_ARCH_TRIPLET_BUILD_FOR/qt6/mkspecs
      - -DINSTALL_PUBLICBINDIR=bin
      - -DBUILD_EXAMPLES=OFF
      - -DBUILD_DOCS=OFF
      - -DFEATURE_mimetype_database=OFF
      - -DFEATURE_dbus_linked=ON
      - -DFEATURE_accessibility=ON
      - -DFEATURE_doubleconversion=ON
      - -DFEATURE_glib=ON
      - -DFEATURE_icu=ON
      - -DFEATURE_pcre2=ON
      - -DFEATURE_system_pcre2=ON
      - -DFEATURE_system_zlib=ON
      - -DFEATURE_ssl=ON
      - -DFEATURE_libproxy=ON
      - -DFEATURE_system_proxies=ON
      - -DFEATURE_cups=ON
      - -DFEATURE_ffmpeg=OFF
      - -DFEATURE_gstreamer=ON
      - -DFEATURE_pulseaudio=ON
      - -DFEATURE_fontconfig=ON
      - -DFEATURE_freetype=ON
      - -DFEATURE_harfbuzz=ON
      - -DFEATURE_gtk=ON
      - -DFEATURE_directfb=OFF
      - -DFEATURE_sql_odbc=ON
      - -DFEATURE_sql_mysql=ON
      - -DFEATURE_sql_psql=ON
      - -DFEATURE_sql_sqlite=ON
      - -DFEATURE_system_sqlite=ON
      - -DFEATURE_jpeg=ON
      - -DFEATURE_system_jpeg=ON
      - -DFEATURE_png=ON
      - -DFEATURE_system_png=ON
      - -DFEATURE_system_libb2=ON
      - -DFEATURE_rpath=OFF
      - -DFEATURE_relocatable=ON
      - -DFEATURE_qtpdf_build=ON
      - -DFEATURE_qtpdf_enable_v8=ON
      - -DFEATURE_qtpdf_quick_build=ON
      - -DFEATURE_qtpdf_widgets_build=ON
      - -DFEATURE_qtwebengine-quick-build=ON
      - -DFEATURE_qtwebengine-widgets-build=ON
      - -DFEATURE_webengine_kerberos=ON
      - -DFEATURE_webengine_proprietary_codecs=ON
      - -DFEATURE_webengine_system_icu=OFF
      # - -DFEATURE_webengine_system_libevent=ON
      - -DFEATURE_webengine-system-libjpeg=on
      - -DFEATURE_webengine-system-libpng=on
      - -DFEATURE_webengine_system_zlib=ON
      - -DFEATURE_webengine_webrtc=ON
      - -DFEATURE_webengine_webrtc-pipewire=ON
      - -DQT_FEATURE_alsa=ON
      - -DFEATURE_use_mold_linker=ON
      - -DBUILD_SHARED_LIBS=ON
    build-snaps:
      - cmake
    build-packages:
      - bison
      - clang
      - default-libmysqlclient-dev
      - firebird-dev
      - flex
      - flite1-dev
      - gettext
      - gperf
      - libasound2-dev
      - libass-dev
      - libatspi2.0-dev
      - libb2-dev
      - libclang-dev
      - libcups2-dev
      - libdbus-1-dev
      - libdouble-conversion-dev
      - libdrm-dev
      - libfontconfig-dev
      - libfontconfig1-dev
      - libfreetype-dev
      - libfreetype6-dev
      - libgbm-dev
      - libgl-dev
      - libgl1-mesa-dev
      - libgles-dev
      - libgles2-mesa-dev
      - libglib2.0-dev
      - libglu-dev
      - libglu1-mesa-dev
      - libglx-dev
      - libgstreamer1.0-dev
      - libgstreamer-plugins-base1.0-dev
      - libgtk-3-dev
      - libharfbuzz-dev
      - libhunspell-dev
      - libicu-dev
      - libinput-dev
      - libjpeg-dev
      - libkrb5-dev
      - liblttng-ust-dev
      - libmd4c-dev
      - libmd4c-html0-dev
      - libmtdev-dev
      - libnss3-dev
      - libopengl-dev
      - libpcre2-dev
      - libpng-dev
      - libpq-dev
      - libproxy-dev
      - libpulse-dev
      - libsctp-dev
      - libsqlite3-dev
      - libssl-dev
      - libsystemd-dev
      - libts-dev
      - libudev-dev
      - libva-dev
      - libwayland-dev
      - libwayland-egl1-mesa
      - libwayland-server0
      - libx11-dev
      - libx11-xcb-dev
      - libxcb-composite0-dev
      - libxcb-cursor-dev
      - libxcb-damage0-dev
      - libxcb-dpms0-dev
      - libxcb-dri2-0-dev
      - libxcb-dri3-dev
      - libxcb-ewmh-dev
      - libxcb-glx0-dev
      - libxcb-icccm4-dev
      - libxcb-image0-dev
      - libxcb-keysyms1-dev
      - libxcb-present-dev
      - libxcb-randr0-dev
      - libxcb-record0-dev
      - libxcb-render-util0-dev
      - libxcb-render0-dev
      - libxcb-res0-dev
      - libxcb-screensaver0-dev
      - libxcb-shape0-dev
      - libxcb-shm0-dev
      - libxcb-sync-dev
      - libxcb-sync0-dev
      - libxcb-util-dev
      - libxcb-xf86dri0-dev
      - libxcb-xfixes0-dev
      - libxcb-xinerama0-dev
      - libxcb-xinput-dev
      - libxcb-xkb-dev
      - libxcb-xrm-dev
      - libxcb-xtest0-dev
      - libxcb-xv0-dev
      - libxcb-xvmc0-dev
      - libxcb1-dev
      - libxcomposite-dev
      - libxcursor-dev
      - libxext-dev
      - libxfixes-dev
      - libxi-dev
      - libxkbcommon-dev
      - libxkbcommon-x11-dev
      - libxkbfile-dev
      - libxrender-dev
      - libxshmfence-dev
      - libxtst-dev
      - libzstd-dev
      - llvm-dev
      - ninja-build
      - nodejs
      - pkg-config
      - python-pip
      - python2-minimal
      - python3-html5lib
      - python3-minimal
      - unixodbc-dev
      - zlib1g-dev
      - git
    stage-packages:
      - libpulse0
    override-pull: |
      craftctl default
      # while read -r PATCHFILE ; do
      #   ls -l
      #   ls -l cmake/
      #   ls -l qtbase/cmake/
      #   pwd
      #   patch -p1 < "$CRAFT_PROJECT_DIR/patches/$PATCHFILE"
      # done < $CRAFT_PROJECT_DIR/patches/series
    override-build: |
      craftctl default
      mkdir -p $CRAFT_PART_INSTALL/etc/$CRAFT_PART_NAME
      cp $CRAFT_PART_BUILD/config.summary $CRAFT_PART_INSTALL/etc/$CRAFT_PART_NAME

  debs:
    after: [qt6]
    plugin: nil
    stage-packages:
      - bison
      - clang
      - default-libmysqlclient-dev
      - docbook
      - docbook-xml
      - docbook-xsl
      - doxygen
      - firebird-dev
      - flex
      - flite1-dev
      - gperf
      - graphviz
      - libasound2-dev
      - libatspi2.0-dev
      - libb2-dev
      - libclang-dev
      - libcups2-dev
      - libdbus-1-dev
      - libdouble-conversion-dev
      - libdrm-dev
      - libfontconfig-dev
      - libfontconfig1-dev
      - libfreetype-dev
      - libfreetype6-dev
      - libgbm-dev
      - libgl-dev
      - libgl1-mesa-dev
      - libgles-dev
      - libgles2-mesa-dev
      - libglib2.0-dev
      - libglu-dev
      - libglu1-mesa-dev
      - libglx-dev
      - libgstreamer1.0-dev
      - libgstreamer-plugins-base1.0-dev
      - libgtk-3-dev
      - libharfbuzz-dev
      - libhunspell-dev
      - libicu-dev
      - libinput-dev
      - libjpeg-dev
      - libkrb5-dev
      - liblttng-ust-dev
      - libmd4c-dev
      - libmd4c-html0-dev
      - libmtdev-dev
      - libnss3-dev
      - libopengl-dev
      - libpcre2-dev
      - libpng-dev
      - libpq-dev
      - libproxy-dev
      - libpulse-dev
      - libsctp-dev
      - libsm-dev
      - libsqlite3-dev
      - libssl-dev
      - libsystemd-dev
      - libts-dev
      - libudev-dev
      - libva-dev
      - libwayland-dev
      - libwayland-egl1-mesa
      - libwayland-server0
      - libx11-dev
      - libx11-xcb-dev
      - libxcb-composite0-dev
      - libxcb-cursor-dev
      - libxcb-damage0-dev
      - libxcb-dpms0-dev
      - libxcb-dri2-0-dev
      - libxcb-dri3-dev
      - libxcb-ewmh-dev
      - libxcb-glx0-dev
      - libxcb-icccm4-dev
      - libxcb-image0-dev
      - libxcb-keysyms1-dev
      - libxcb-present-dev
      - libxcb-randr0-dev
      - libxcb-record0-dev
      - libxcb-render-util0-dev
      - libxcb-render0-dev
      - libxcb-res0-dev
      - libxcb-screensaver0-dev
      - libxcb-shape0-dev
      - libxcb-shm0-dev
      - libxcb-sync-dev
      - libxcb-sync0-dev
      - libxcb-util-dev
      - libxcb-xf86dri0-dev
      - libxcb-xfixes0-dev
      - libxcb-xinerama0-dev
      - libxcb-xinput-dev
      - libxcb-xkb-dev
      - libxcb-xrm-dev
      - libxcb-xtest0-dev
      - libxcb-xv0-dev
      - libxcb-xvmc0-dev
      - libxcb1-dev
      - libxcomposite-dev
      - libxcursor-dev
      - libxext-dev
      - libxfixes-dev
      - libxi-dev
      - libxkbcommon-dev
      - libxkbcommon-x11-dev
      - libxkbfile-dev
      - libxrender-dev
      - libxshmfence-dev
      - libxtst-dev
      - libzstd-dev
      - llvm-dev
      - ninja-build
      - nodejs
      - pkg-config
      - python-pip
      - python2-minimal
      - python3-html5lib
      - python3-minimal
      - unixodbc-dev
      - zlib1g-dev
      - gettext
      - sgml-data
      - libxml2-utils
      - libglvnd-dev
    prime:
      - -lib
      - -usr/lib/systemd
      - -usr/share/bug
      - -usr/share/dbus-1
      - -usr/share/doc
      - -usr/share/doc-base
      - -usr/share/lintian
      - -usr/share/man
      - -usr/lib/*/*.a
    override-stage: |
        craftctl default
        find $CRAFT_STAGE -type f,l -name "*.pc" -exec bash -c "sed -i 's:/build/kde-qt6-core22-sdk/stage/:/snap/$CRAFT_PROJECT_NAME/current:g' {}*" \;
        find $CRAFT_STAGE -type f,l -name "*.pc" -exec bash -c "sed -i 's:/root/stage:/snap/$CRAFT_PROJECT_NAME/current:g' {}*" \;
        find $CRAFT_STAGE -type f,l -name "*.pc" -exec bash -c "sed -i 's:libdir=/usr:libdir=/snap/$CRAFT_PROJECT_NAME/current/usr:g' {}*" \;
        find $CRAFT_STAGE -type f,l -name "*.pc" -exec bash -c "sed -i 's:includedir=/usr:includedir=/snap/$CRAFT_PROJECT_NAME/current/usr:g' {}*" \;


  cleanup:
    plugin: nil
    after: [debs]
    override-stage: |
      set -eux
      for snap in "core22"; do
        cd "/snap/$snap/current" && find . -type f,l -exec rm -f "$CRAFT_PRIME/{}" \;
      done
